/********************************** AT_DMA92.H *********************************

Copyright Symbios Logic

Author:		Symbios Logic Systems Engineer
Purpose:	53C80S Demonstration Software

This software was written by Symbios to develop and test new products.
It is not a general SCSI driver.  NCR assumes no liability for its use,
misuse or inability to use.

Project files:
		C80S.C 		Main body of code
		TARGET80.C	Target Mode routines
		CF80ISR.C	Interrupt Service Routine
		CF80TEST.C	Automatic Test Module
		AT_DMA80.C	Hardware dependant DMA code (8237 compatible)
		AT_DMA80.H  	DMA controller parameters
		C80S_AT.H	Hardware addresses, global defines
		C80S_EV.H	External variables

***************************************************************************/

/* 8237A DMA controller register addresses in the IBM AT */

#define dma3_page	0x82	/* DMA channel 3 page register 		*/
#define dma3_addrs	0x06	/* DMA channel 3 address pointer 	*/
#define dma3_count	0x07	/* DMA channel 3 transfer count 	*/

#define dma_status	0x08	/* DMA Read Status Register	    */
#define dma_command	0x08	/* DMA Write Command Register	    */
#define dma_request	0x09	/* DMA Write Request Register	    */
#define dma_mask	0x0A	/* DMA Write Single Mask Register   */
#define dma_mode	0x0B	/* DMA Write Mode Register	    */
#define dma_flop	0x0C	/* DMA Clear Byte Pointer Flip Flop */

/* 8237 DMA controller bit settings for the AT.
   Appropriate bits should be OR'ed together */

#define ch0		0x00	/* DMA channel 0 */
#define ch1		0x01	/* DMA channel 1 */
#define ch2		0x02	/* DMA channel 2 */
#define ch3		0x03    /* DMA channel 3 */

#define WT		0x04	/* mode register memory write */
#define RD		0x08	/* mode register memory read  */

/* #define demand		0x00	/* mode register demand mode     */
#define single		0x40	/* mode register single transfer */
/* #define block		0x80	/* mode register block transfer  */
/* #define cascade		0xC0	/* mode register cascade mode    */


/* defined in AT_DMA80.C */
void initIBMdma(void far *start_addrs, unsigned long numbytes, char rw);
void calc_abs_adrs (void far *ptr);



