/********************************** C80S_AT.H *********************************
Copyright Symbios Logic Inc.

Author:		Sherri Moore Symbios Logic System Applications Engineer
Purpose:		53C80S Demonstration Software

This software was written by Symbios Logic to develop and test new
products.  It is not a general SCSI driver.  Symbios Logic assumes no liability for
its use, misuse or inability to use.

Project files:
		C80S.C 		Main body of code
		TARGET80.C	Target Mode routines
		C80SISR.C	Interrupt Service Routine
		C80STEST.C	Automatic Test Module
		DMA80S.C	Hardware dependant DMA code (8237 compatible)
		DMA80S.H  	DMA controller parameters
		C80S_AT.H	Hardware addresses, global defines
		C80S_EV.H	External variables
		C80SCAM.H

rev 1.0	  7-95	Initial release as C80SDEMO
************************************************************************/

#define true  1
#define false 0

#define base	0x300			/* base address of the 53C80S */

#define scsi_data	base+0		/* R - Current SCSI Data, W - Output Data*/
#define init_cmd	base+1		/* R/W - Initiator Command Reg */
#define mod_reg		base+2		/* R/W - Mode Reg*/
#define tgt_cmd		base+3		/* R/W - Target Command reg*/
#define scsi_bus	base+4		/* R - Current SCSI Bus Status */
#define sel_ena		base+4		/* W - Select Enable */
#define stat_reg	base+5		/* R - Bus & Status*/
#define dma_send	base+5		/* W - Start DMA Send */
#define in_data		base+6		/* R - Input Data*/
#define dma_tgt_rcv	base+6		/* W - Start DMA Target Receive*/
#define rst_int		base+7		/* R - Reset Parity/Interrupt*/
#define dma_init_rcv	base+7		/* W - Start DMA Initiator Receive*/


/************************** Function Declarations **************************/

/* defined in C80S.C */
void main(void);
void init(void);
void load_regs(void);
void fillbuff(unsigned char pattern, unsigned int start);
void dumpbuf(void);
void setup(void);
void scsi_menu(void);
void tur (void);
void DATA_DRIVER(char rw, unsigned short cdb_len, int data_len);
void select(unsigned short cdb_len);
void dma_xfer_data(char far* start_addrs, int count, char rw);
void nonDMA_xfer_data(char far* start_addrs, int count, char rw);
void cmdcomp(void);
void message(void);
void DMA_CDB(char rw);
void rqsense(unsigned short cdb_len);
void Message_In();
void read_regs(void);
void Init_REQ_ACK(char rw);
unsigned char inquiry(void);

/* defined in TARGET80.C */
void Tinquiry(void);
void target_mode(void);
void REQ_ACK(void);
void Ttest_ready(void);
void Trqsense(void);
void Tread(void);
void Twrite(void);
void dis_resel(void);


/* defined in C80STEST.C */
void test_driver (void);
void asynch_test(void);
void dma_cdb_test(void);
void check_buf(unsigned int start);
void EXSCSI(char rw);

/* defined in C80SISR.C */
void isr(int phase);

/* defined in AT_DMA80.C */
void initIBMdma(void far *start_addrs, unsigned long numbytes, char rw);
void calc_abs_adrs(void far *ptr);

/* defined in C80SCAM.C */
void SCAM_menu(void);
unsigned char SCAM_selected(void);
unsigned char SCAM_trans(unsigned char data);
unsigned char SCAM_isolation(void);